/*
 * generated by Xtext 2.25.0
 */
package tdt4250.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.EnumLiteralDeclaration;
import org.eclipse.xtext.EnumRule;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class XjavaGrammarAccess extends AbstractElementFinder.AbstractGrammarElementFinder {
	
	public class CompilationUnitElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.Xjava.CompilationUnit");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cPackageDeclAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cPackageDeclPackageDeclarationParserRuleCall_0_0 = (RuleCall)cPackageDeclAssignment_0.eContents().get(0);
		private final Assignment cImportsAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cImportsImportStatementParserRuleCall_1_0 = (RuleCall)cImportsAssignment_1.eContents().get(0);
		private final Assignment cClassesAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cClassesTypeDeclarationParserRuleCall_2_0 = (RuleCall)cClassesAssignment_2.eContents().get(0);
		
		//CompilationUnit:
		//    packageDecl = PackageDeclaration
		//    imports += ImportStatement*
		//    classes += TypeDeclaration+
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//packageDecl = PackageDeclaration
		//imports += ImportStatement*
		//classes += TypeDeclaration+
		public Group getGroup() { return cGroup; }
		
		//packageDecl = PackageDeclaration
		public Assignment getPackageDeclAssignment_0() { return cPackageDeclAssignment_0; }
		
		//PackageDeclaration
		public RuleCall getPackageDeclPackageDeclarationParserRuleCall_0_0() { return cPackageDeclPackageDeclarationParserRuleCall_0_0; }
		
		//imports += ImportStatement*
		public Assignment getImportsAssignment_1() { return cImportsAssignment_1; }
		
		//ImportStatement
		public RuleCall getImportsImportStatementParserRuleCall_1_0() { return cImportsImportStatementParserRuleCall_1_0; }
		
		//classes += TypeDeclaration+
		public Assignment getClassesAssignment_2() { return cClassesAssignment_2; }
		
		//TypeDeclaration
		public RuleCall getClassesTypeDeclarationParserRuleCall_2_0() { return cClassesTypeDeclarationParserRuleCall_2_0; }
	}
	public class QNameElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.Xjava.QName");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final RuleCall cIDTerminalRuleCall_0 = (RuleCall)cGroup.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Keyword cFullStopKeyword_1_0 = (Keyword)cGroup_1.eContents().get(0);
		private final RuleCall cIDTerminalRuleCall_1_1 = (RuleCall)cGroup_1.eContents().get(1);
		
		//QName: ID ('.' ID)*;
		@Override public ParserRule getRule() { return rule; }
		
		//ID ('.' ID)*
		public Group getGroup() { return cGroup; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_0() { return cIDTerminalRuleCall_0; }
		
		//('.' ID)*
		public Group getGroup_1() { return cGroup_1; }
		
		//'.'
		public Keyword getFullStopKeyword_1_0() { return cFullStopKeyword_1_0; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_1_1() { return cIDTerminalRuleCall_1_1; }
	}
	public class PackageDeclarationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.Xjava.PackageDeclaration");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cPackageKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameQNameParserRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cSemicolonKeyword_2 = (Keyword)cGroup.eContents().get(2);
		
		//PackageDeclaration:
		//    'package' name = QName ';'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'package' name = QName ';'
		public Group getGroup() { return cGroup; }
		
		//'package'
		public Keyword getPackageKeyword_0() { return cPackageKeyword_0; }
		
		//name = QName
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//QName
		public RuleCall getNameQNameParserRuleCall_1_0() { return cNameQNameParserRuleCall_1_0; }
		
		//';'
		public Keyword getSemicolonKeyword_2() { return cSemicolonKeyword_2; }
	}
	public class ImportStatementElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.Xjava.ImportStatement");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cImportKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameQNameParserRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cSemicolonKeyword_2 = (Keyword)cGroup.eContents().get(2);
		
		//ImportStatement:
		//    'import' name = QName ';'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'import' name = QName ';'
		public Group getGroup() { return cGroup; }
		
		//'import'
		public Keyword getImportKeyword_0() { return cImportKeyword_0; }
		
		//name = QName
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//QName
		public RuleCall getNameQNameParserRuleCall_1_0() { return cNameQNameParserRuleCall_1_0; }
		
		//';'
		public Keyword getSemicolonKeyword_2() { return cSemicolonKeyword_2; }
	}
	public class TypeDeclarationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.Xjava.TypeDeclaration");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cClassKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Group cGroup_2 = (Group)cGroup.eContents().get(2);
		private final Keyword cExtendsKeyword_2_0 = (Keyword)cGroup_2.eContents().get(0);
		private final Assignment cSuperTypeRefAssignment_2_1 = (Assignment)cGroup_2.eContents().get(1);
		private final RuleCall cSuperTypeRefTypeReferenceParserRuleCall_2_1_0 = (RuleCall)cSuperTypeRefAssignment_2_1.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Alternatives cAlternatives_4 = (Alternatives)cGroup.eContents().get(4);
		private final Assignment cFieldDeclsAssignment_4_0 = (Assignment)cAlternatives_4.eContents().get(0);
		private final RuleCall cFieldDeclsFieldDeclarationParserRuleCall_4_0_0 = (RuleCall)cFieldDeclsAssignment_4_0.eContents().get(0);
		private final Assignment cMethodDeclsAssignment_4_1 = (Assignment)cAlternatives_4.eContents().get(1);
		private final RuleCall cMethodDeclsMethodDeclarationParserRuleCall_4_1_0 = (RuleCall)cMethodDeclsAssignment_4_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_5 = (Keyword)cGroup.eContents().get(5);
		
		//TypeDeclaration:
		//    'class' name = ID ('extends' superTypeRef = TypeReference)? '{'
		//        ((fieldDecls += FieldDeclaration) |
		//        (methodDecls += MethodDeclaration))*
		//    '}'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//'class' name = ID ('extends' superTypeRef = TypeReference)? '{'
		//    ((fieldDecls += FieldDeclaration) |
		//    (methodDecls += MethodDeclaration))*
		//'}'
		public Group getGroup() { return cGroup; }
		
		//'class'
		public Keyword getClassKeyword_0() { return cClassKeyword_0; }
		
		//name = ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//('extends' superTypeRef = TypeReference)?
		public Group getGroup_2() { return cGroup_2; }
		
		//'extends'
		public Keyword getExtendsKeyword_2_0() { return cExtendsKeyword_2_0; }
		
		//superTypeRef = TypeReference
		public Assignment getSuperTypeRefAssignment_2_1() { return cSuperTypeRefAssignment_2_1; }
		
		//TypeReference
		public RuleCall getSuperTypeRefTypeReferenceParserRuleCall_2_1_0() { return cSuperTypeRefTypeReferenceParserRuleCall_2_1_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_3() { return cLeftCurlyBracketKeyword_3; }
		
		//((fieldDecls += FieldDeclaration) |
		//(methodDecls += MethodDeclaration))*
		public Alternatives getAlternatives_4() { return cAlternatives_4; }
		
		//(fieldDecls += FieldDeclaration)
		public Assignment getFieldDeclsAssignment_4_0() { return cFieldDeclsAssignment_4_0; }
		
		//FieldDeclaration
		public RuleCall getFieldDeclsFieldDeclarationParserRuleCall_4_0_0() { return cFieldDeclsFieldDeclarationParserRuleCall_4_0_0; }
		
		//(methodDecls += MethodDeclaration)
		public Assignment getMethodDeclsAssignment_4_1() { return cMethodDeclsAssignment_4_1; }
		
		//MethodDeclaration
		public RuleCall getMethodDeclsMethodDeclarationParserRuleCall_4_1_0() { return cMethodDeclsMethodDeclarationParserRuleCall_4_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_5() { return cRightCurlyBracketKeyword_5; }
	}
	public class FieldDeclarationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.Xjava.FieldDeclaration");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cVisibilityAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cVisibilityVisibilityEnumRuleCall_0_0 = (RuleCall)cVisibilityAssignment_0.eContents().get(0);
		private final Assignment cTypeRefAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cTypeRefTypeReferenceParserRuleCall_1_0 = (RuleCall)cTypeRefAssignment_1.eContents().get(0);
		private final Assignment cNameAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cNameIDTerminalRuleCall_2_0 = (RuleCall)cNameAssignment_2.eContents().get(0);
		private final Keyword cSemicolonKeyword_3 = (Keyword)cGroup.eContents().get(3);
		
		//FieldDeclaration:
		//    visibility = Visibility?
		//    typeRef = TypeReference
		//    name = ID
		//    ';'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//visibility = Visibility?
		//typeRef = TypeReference
		//name = ID
		//';'
		public Group getGroup() { return cGroup; }
		
		//visibility = Visibility?
		public Assignment getVisibilityAssignment_0() { return cVisibilityAssignment_0; }
		
		//Visibility
		public RuleCall getVisibilityVisibilityEnumRuleCall_0_0() { return cVisibilityVisibilityEnumRuleCall_0_0; }
		
		//typeRef = TypeReference
		public Assignment getTypeRefAssignment_1() { return cTypeRefAssignment_1; }
		
		//TypeReference
		public RuleCall getTypeRefTypeReferenceParserRuleCall_1_0() { return cTypeRefTypeReferenceParserRuleCall_1_0; }
		
		//name = ID
		public Assignment getNameAssignment_2() { return cNameAssignment_2; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_2_0() { return cNameIDTerminalRuleCall_2_0; }
		
		//';'
		public Keyword getSemicolonKeyword_3() { return cSemicolonKeyword_3; }
	}
	public class MethodDeclarationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.Xjava.MethodDeclaration");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cVisibilityAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cVisibilityVisibilityEnumRuleCall_0_0 = (RuleCall)cVisibilityAssignment_0.eContents().get(0);
		private final Assignment cTypeRefAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cTypeRefTypeReferenceParserRuleCall_1_0 = (RuleCall)cTypeRefAssignment_1.eContents().get(0);
		private final Assignment cNameAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cNameIDTerminalRuleCall_2_0 = (RuleCall)cNameAssignment_2.eContents().get(0);
		private final Keyword cLeftParenthesisKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Assignment cParametersAssignment_4_0 = (Assignment)cGroup_4.eContents().get(0);
		private final RuleCall cParametersParameterDeclarationParserRuleCall_4_0_0 = (RuleCall)cParametersAssignment_4_0.eContents().get(0);
		private final Group cGroup_4_1 = (Group)cGroup_4.eContents().get(1);
		private final Keyword cCommaKeyword_4_1_0 = (Keyword)cGroup_4_1.eContents().get(0);
		private final Assignment cParametersAssignment_4_1_1 = (Assignment)cGroup_4_1.eContents().get(1);
		private final RuleCall cParametersParameterDeclarationParserRuleCall_4_1_1_0 = (RuleCall)cParametersAssignment_4_1_1.eContents().get(0);
		private final Keyword cRightParenthesisKeyword_5 = (Keyword)cGroup.eContents().get(5);
		private final Keyword cLeftCurlyBracketKeyword_6 = (Keyword)cGroup.eContents().get(6);
		private final Keyword cRightCurlyBracketKeyword_7 = (Keyword)cGroup.eContents().get(7);
		
		//MethodDeclaration:
		//    visibility = Visibility?
		//    typeRef = TypeReference
		//    name = ID '('
		//        (parameters += ParameterDeclaration (',' parameters += ParameterDeclaration)*)?
		//    ')' '{'
		//    '}'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//visibility = Visibility?
		//typeRef = TypeReference
		//name = ID '('
		//    (parameters += ParameterDeclaration (',' parameters += ParameterDeclaration)*)?
		//')' '{'
		//'}'
		public Group getGroup() { return cGroup; }
		
		//visibility = Visibility?
		public Assignment getVisibilityAssignment_0() { return cVisibilityAssignment_0; }
		
		//Visibility
		public RuleCall getVisibilityVisibilityEnumRuleCall_0_0() { return cVisibilityVisibilityEnumRuleCall_0_0; }
		
		//typeRef = TypeReference
		public Assignment getTypeRefAssignment_1() { return cTypeRefAssignment_1; }
		
		//TypeReference
		public RuleCall getTypeRefTypeReferenceParserRuleCall_1_0() { return cTypeRefTypeReferenceParserRuleCall_1_0; }
		
		//name = ID
		public Assignment getNameAssignment_2() { return cNameAssignment_2; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_2_0() { return cNameIDTerminalRuleCall_2_0; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_3() { return cLeftParenthesisKeyword_3; }
		
		//(parameters += ParameterDeclaration (',' parameters += ParameterDeclaration)*)?
		public Group getGroup_4() { return cGroup_4; }
		
		//parameters += ParameterDeclaration
		public Assignment getParametersAssignment_4_0() { return cParametersAssignment_4_0; }
		
		//ParameterDeclaration
		public RuleCall getParametersParameterDeclarationParserRuleCall_4_0_0() { return cParametersParameterDeclarationParserRuleCall_4_0_0; }
		
		//(',' parameters += ParameterDeclaration)*
		public Group getGroup_4_1() { return cGroup_4_1; }
		
		//','
		public Keyword getCommaKeyword_4_1_0() { return cCommaKeyword_4_1_0; }
		
		//parameters += ParameterDeclaration
		public Assignment getParametersAssignment_4_1_1() { return cParametersAssignment_4_1_1; }
		
		//ParameterDeclaration
		public RuleCall getParametersParameterDeclarationParserRuleCall_4_1_1_0() { return cParametersParameterDeclarationParserRuleCall_4_1_1_0; }
		
		//')'
		public Keyword getRightParenthesisKeyword_5() { return cRightParenthesisKeyword_5; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_6() { return cLeftCurlyBracketKeyword_6; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_7() { return cRightCurlyBracketKeyword_7; }
	}
	public class ParameterDeclarationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.Xjava.ParameterDeclaration");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cTypeRefAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cTypeRefTypeReferenceParserRuleCall_0_0 = (RuleCall)cTypeRefAssignment_0.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		
		//ParameterDeclaration:
		//    typeRef = TypeReference
		//    name = ID
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//typeRef = TypeReference
		//name = ID
		public Group getGroup() { return cGroup; }
		
		//typeRef = TypeReference
		public Assignment getTypeRefAssignment_0() { return cTypeRefAssignment_0; }
		
		//TypeReference
		public RuleCall getTypeRefTypeReferenceParserRuleCall_0_0() { return cTypeRefTypeReferenceParserRuleCall_0_0; }
		
		//name = ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
	}
	public class TypeReferenceElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.Xjava.TypeReference");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cTypeNameAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cTypeNameQNameParserRuleCall_0_0 = (RuleCall)cTypeNameAssignment_0.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Keyword cLessThanSignKeyword_1_0 = (Keyword)cGroup_1.eContents().get(0);
		private final Assignment cTypeParametersAssignment_1_1 = (Assignment)cGroup_1.eContents().get(1);
		private final RuleCall cTypeParametersTypeReferenceParserRuleCall_1_1_0 = (RuleCall)cTypeParametersAssignment_1_1.eContents().get(0);
		private final Group cGroup_1_2 = (Group)cGroup_1.eContents().get(2);
		private final Keyword cCommaKeyword_1_2_0 = (Keyword)cGroup_1_2.eContents().get(0);
		private final Assignment cTypeParametersAssignment_1_2_1 = (Assignment)cGroup_1_2.eContents().get(1);
		private final RuleCall cTypeParametersTypeReferenceParserRuleCall_1_2_1_0 = (RuleCall)cTypeParametersAssignment_1_2_1.eContents().get(0);
		private final Keyword cGreaterThanSignKeyword_1_3 = (Keyword)cGroup_1.eContents().get(3);
		
		//TypeReference:
		//    typeName = QName
		//    ('<' typeParameters += TypeReference (',' typeParameters += TypeReference)* '>')?
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//typeName = QName
		//('<' typeParameters += TypeReference (',' typeParameters += TypeReference)* '>')?
		public Group getGroup() { return cGroup; }
		
		//typeName = QName
		public Assignment getTypeNameAssignment_0() { return cTypeNameAssignment_0; }
		
		//QName
		public RuleCall getTypeNameQNameParserRuleCall_0_0() { return cTypeNameQNameParserRuleCall_0_0; }
		
		//('<' typeParameters += TypeReference (',' typeParameters += TypeReference)* '>')?
		public Group getGroup_1() { return cGroup_1; }
		
		//'<'
		public Keyword getLessThanSignKeyword_1_0() { return cLessThanSignKeyword_1_0; }
		
		//typeParameters += TypeReference
		public Assignment getTypeParametersAssignment_1_1() { return cTypeParametersAssignment_1_1; }
		
		//TypeReference
		public RuleCall getTypeParametersTypeReferenceParserRuleCall_1_1_0() { return cTypeParametersTypeReferenceParserRuleCall_1_1_0; }
		
		//(',' typeParameters += TypeReference)*
		public Group getGroup_1_2() { return cGroup_1_2; }
		
		//','
		public Keyword getCommaKeyword_1_2_0() { return cCommaKeyword_1_2_0; }
		
		//typeParameters += TypeReference
		public Assignment getTypeParametersAssignment_1_2_1() { return cTypeParametersAssignment_1_2_1; }
		
		//TypeReference
		public RuleCall getTypeParametersTypeReferenceParserRuleCall_1_2_1_0() { return cTypeParametersTypeReferenceParserRuleCall_1_2_1_0; }
		
		//'>'
		public Keyword getGreaterThanSignKeyword_1_3() { return cGreaterThanSignKeyword_1_3; }
	}
	
	public class VisibilityElements extends AbstractElementFinder.AbstractEnumRuleElementFinder {
		private final EnumRule rule = (EnumRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.Xjava.Visibility");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final EnumLiteralDeclaration cPRIVATEEnumLiteralDeclaration_0 = (EnumLiteralDeclaration)cAlternatives.eContents().get(0);
		private final Keyword cPRIVATEPrivateKeyword_0_0 = (Keyword)cPRIVATEEnumLiteralDeclaration_0.eContents().get(0);
		private final EnumLiteralDeclaration cPUBLICEnumLiteralDeclaration_1 = (EnumLiteralDeclaration)cAlternatives.eContents().get(1);
		private final Keyword cPUBLICPublicKeyword_1_0 = (Keyword)cPUBLICEnumLiteralDeclaration_1.eContents().get(0);
		private final EnumLiteralDeclaration cPROTECTEDEnumLiteralDeclaration_2 = (EnumLiteralDeclaration)cAlternatives.eContents().get(2);
		private final Keyword cPROTECTEDProtectedKeyword_2_0 = (Keyword)cPROTECTEDEnumLiteralDeclaration_2.eContents().get(0);
		
		//enum Visibility:
		//    PRIVATE = 'private' |
		//    PUBLIC = 'public' |
		//    PROTECTED = 'protected'
		//;
		public EnumRule getRule() { return rule; }
		
		//PRIVATE = 'private' |
		//PUBLIC = 'public' |
		//PROTECTED = 'protected'
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//PRIVATE = 'private'
		public EnumLiteralDeclaration getPRIVATEEnumLiteralDeclaration_0() { return cPRIVATEEnumLiteralDeclaration_0; }
		
		//'private'
		public Keyword getPRIVATEPrivateKeyword_0_0() { return cPRIVATEPrivateKeyword_0_0; }
		
		//PUBLIC = 'public'
		public EnumLiteralDeclaration getPUBLICEnumLiteralDeclaration_1() { return cPUBLICEnumLiteralDeclaration_1; }
		
		//'public'
		public Keyword getPUBLICPublicKeyword_1_0() { return cPUBLICPublicKeyword_1_0; }
		
		//PROTECTED = 'protected'
		public EnumLiteralDeclaration getPROTECTEDEnumLiteralDeclaration_2() { return cPROTECTEDEnumLiteralDeclaration_2; }
		
		//'protected'
		public Keyword getPROTECTEDProtectedKeyword_2_0() { return cPROTECTEDProtectedKeyword_2_0; }
	}
	
	private final CompilationUnitElements pCompilationUnit;
	private final QNameElements pQName;
	private final PackageDeclarationElements pPackageDeclaration;
	private final ImportStatementElements pImportStatement;
	private final TypeDeclarationElements pTypeDeclaration;
	private final VisibilityElements eVisibility;
	private final FieldDeclarationElements pFieldDeclaration;
	private final MethodDeclarationElements pMethodDeclaration;
	private final ParameterDeclarationElements pParameterDeclaration;
	private final TypeReferenceElements pTypeReference;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public XjavaGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pCompilationUnit = new CompilationUnitElements();
		this.pQName = new QNameElements();
		this.pPackageDeclaration = new PackageDeclarationElements();
		this.pImportStatement = new ImportStatementElements();
		this.pTypeDeclaration = new TypeDeclarationElements();
		this.eVisibility = new VisibilityElements();
		this.pFieldDeclaration = new FieldDeclarationElements();
		this.pMethodDeclaration = new MethodDeclarationElements();
		this.pParameterDeclaration = new ParameterDeclarationElements();
		this.pTypeReference = new TypeReferenceElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("tdt4250.Xjava".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//CompilationUnit:
	//    packageDecl = PackageDeclaration
	//    imports += ImportStatement*
	//    classes += TypeDeclaration+
	//;
	public CompilationUnitElements getCompilationUnitAccess() {
		return pCompilationUnit;
	}
	
	public ParserRule getCompilationUnitRule() {
		return getCompilationUnitAccess().getRule();
	}
	
	//QName: ID ('.' ID)*;
	public QNameElements getQNameAccess() {
		return pQName;
	}
	
	public ParserRule getQNameRule() {
		return getQNameAccess().getRule();
	}
	
	//PackageDeclaration:
	//    'package' name = QName ';'
	//;
	public PackageDeclarationElements getPackageDeclarationAccess() {
		return pPackageDeclaration;
	}
	
	public ParserRule getPackageDeclarationRule() {
		return getPackageDeclarationAccess().getRule();
	}
	
	//ImportStatement:
	//    'import' name = QName ';'
	//;
	public ImportStatementElements getImportStatementAccess() {
		return pImportStatement;
	}
	
	public ParserRule getImportStatementRule() {
		return getImportStatementAccess().getRule();
	}
	
	//TypeDeclaration:
	//    'class' name = ID ('extends' superTypeRef = TypeReference)? '{'
	//        ((fieldDecls += FieldDeclaration) |
	//        (methodDecls += MethodDeclaration))*
	//    '}'
	//;
	public TypeDeclarationElements getTypeDeclarationAccess() {
		return pTypeDeclaration;
	}
	
	public ParserRule getTypeDeclarationRule() {
		return getTypeDeclarationAccess().getRule();
	}
	
	//enum Visibility:
	//    PRIVATE = 'private' |
	//    PUBLIC = 'public' |
	//    PROTECTED = 'protected'
	//;
	public VisibilityElements getVisibilityAccess() {
		return eVisibility;
	}
	
	public EnumRule getVisibilityRule() {
		return getVisibilityAccess().getRule();
	}
	
	//FieldDeclaration:
	//    visibility = Visibility?
	//    typeRef = TypeReference
	//    name = ID
	//    ';'
	//;
	public FieldDeclarationElements getFieldDeclarationAccess() {
		return pFieldDeclaration;
	}
	
	public ParserRule getFieldDeclarationRule() {
		return getFieldDeclarationAccess().getRule();
	}
	
	//MethodDeclaration:
	//    visibility = Visibility?
	//    typeRef = TypeReference
	//    name = ID '('
	//        (parameters += ParameterDeclaration (',' parameters += ParameterDeclaration)*)?
	//    ')' '{'
	//    '}'
	//;
	public MethodDeclarationElements getMethodDeclarationAccess() {
		return pMethodDeclaration;
	}
	
	public ParserRule getMethodDeclarationRule() {
		return getMethodDeclarationAccess().getRule();
	}
	
	//ParameterDeclaration:
	//    typeRef = TypeReference
	//    name = ID
	//;
	public ParameterDeclarationElements getParameterDeclarationAccess() {
		return pParameterDeclaration;
	}
	
	public ParserRule getParameterDeclarationRule() {
		return getParameterDeclarationAccess().getRule();
	}
	
	//TypeReference:
	//    typeName = QName
	//    ('<' typeParameters += TypeReference (',' typeParameters += TypeReference)* '>')?
	//;
	public TypeReferenceElements getTypeReferenceAccess() {
		return pTypeReference;
	}
	
	public ParserRule getTypeReferenceRule() {
		return getTypeReferenceAccess().getRule();
	}
	
	//terminal ID: '^'?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt: ('0'..'9')+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//            '"' ( '\\' . /* 'b'|'t'|'n'|'f'|'r'|'u'|'"'|"'"|'\\' */ | !('\\'|'"') )* '"' |
	//            "'" ( '\\' . /* 'b'|'t'|'n'|'f'|'r'|'u'|'"'|"'"|'\\' */ | !('\\'|"'") )* "'"
	//        ;
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT : '/*' -> '*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT : '//' !('\n'|'\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS         : (' '|'\t'|'\r'|'\n')+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER: .;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
